T1 特殊字符串

解题思路

\(f_{i,j}\) 表示前 \(i\) 个字符中结尾为 \(j\) 的最大贡献。

转移枚举当前位置于之前位置结尾的组合加上贡献即可。

对于边界问题,容易发现选择 1 一定不劣。

code

#include<bits/stdc++.h>
#define int long long
#define ull unsigned long long
#define f() cout<<"RP++"<<endl
using namespace std;
inline int read()
{
int x=0,f=1;char ch=getchar();
while(ch>'9'||ch<'0'){if(ch=='-')f=-1;ch=getchar();}
while(ch>='0'&&ch<='9'){x=(x<<1)+(x<<3)+(ch^48);ch=getchar();}
return x*f;
}
const int N=1e5+10,INF=1e18;
int n,m,ans,f[N][30],val[30][30];
char s[N],ch1,ch2;
#undef int
int main()
{
#define int long long
freopen("shiki.in","r",stdin); freopen("shiki.out","w",stdout);
n=read(); scanf("%s",s+1); m=read();
for(int i=1,v;i<=m;i++)
{
getchar(); ch1=getchar(); getchar(); ch2=getchar(); v=read();
val[ch1-'a'][ch2-'a']+=v;
}
for(int i=1;i<=n;i++) for(int j=0;j<26;j++) f[i][j]=-INF; f[1][s[1]-'a']=0;
for(int i=2;i<=n;i++)
{
for(int j=0;j<26;j++) f[i][j]=f[i-1][j];
for(int j=0;j<26;j++) f[i][s[i]-'a']=max(f[i][s[i]-'a'],f[i-1][j]+val[j][s[i]-'a']);
}
for(int i=0;i<26;i++) ans=max(ans,f[n][i]); printf("%lld",ans);
return 0;
}

T2 宝可梦

解题思路

调了一下午,换了两三种做法,最后换回我原来的做法,尝试着调了一下段错误,发现真的只是数组开小了那么简单!!!

我还以为是系统栈空间炸了。。。

如果当前方向是可以走的话直接向前走,否则的话因为是沿着右墙走所以直接左转。

然后对于右手边没有墙的时候,就直接向右手边走就好了。50行精品超短小暴力

由于题目保证路径是唯一的因此所有点之间形成了一种树形结构。

那么我们选择一个出发点一直走一定会遍历完整张图,并且形成了一个欧拉序。

于是我们就可以对于一个点按照正反方向走两边(询问是有方向的),对于每一个询问查找对应点之间的距离就好了。

code

#include<bits/stdc++.h>
#define int long long
#define ull unsigned long long
#define f() cout<<"RP++"<<endl
using namespace std;
inline int read()
{
int x=0,f=1;char ch=getchar();
while(ch>'9'||ch<'0'){if(ch=='-')f=-1;ch=getchar();}
while(ch>='0'&&ch<='9'){x=(x<<1)+(x<<3)+(ch^48);ch=getchar();}
return x*f;
}
const int N=5e5+10,INF=1e18;
int n,m,q,all,sum[10],pos[5][N][5];
int r[10]={0,4,3,1,2},l[10]={0,3,4,2,1};
int d1[10]={0,-1,1,0,0},d2[10]={0,0,0,-1,1};
vector<char> e[N];
bool vis[N];
char ch[N];
inline int id(int x,int y){return (x-1)*m+y;}
void work(int x,int y,int fx)
{
int p=fx,tx=x,ty=y;
pos[p][id(x,y)][fx]=min(pos[p][id(x,y)][fx],sum[p]);
int nx=x+d1[fx],ny=y+d2[fx];
if(e[nx][ny]=='.') sum[p]++,x=nx,y=ny;
else fx=l[fx];
if(e[x+d1[r[fx]]][y+d2[r[fx]]]=='.') fx=r[fx];
while(x!=tx||y!=ty||p!=fx)
{
pos[p][id(x,y)][fx]=min(pos[p][id(x,y)][fx],sum[p]);
int nx=x+d1[fx],ny=y+d2[fx];
if(x==tx&&y==ty&&fx==p) break;
if(e[nx][ny]=='.') sum[p]++,x=nx,y=ny;
else for(int i=1;i<=3;i++)
{
fx=r[fx];
if(x==tx&&y==ty&&fx==p) break;
}
if(x==tx&&y==ty&&fx==p) break;
if(e[x+d1[r[fx]]][y+d2[r[fx]]]=='.') fx=r[fx];
}
}
#undef int
int main()
{
#define int long long
freopen("pokemon.in","r",stdin); freopen("pokemon.out","w",stdout);
n=read(); m=read(); memset(pos,0x3f,sizeof(pos));
for(int i=1;i<=n;i++)
{
e[i].push_back('X'); scanf("%s",ch+1);
for(int j=1;j<=m;j++) e[i].push_back(ch[j]);
e[i].push_back('X');
}
for(int i=0;i<=m+1;i++) e[0].push_back('X'),e[n+1].push_back('X');
for(int i=1;i<=n;i++) for(int j=1;j<=m;j++) all+=(e[i][j]=='.');
for(int i=1;i<=n;i++) for(int j=1;j<=m;j++) if(e[i][j]=='.'){for(int k=1;k<=2;k++)work(i,j,k);goto V;}
V:; q=read();
while(q--)
{
int x,y,tx,ty,fx; x=read(); y=read(); tx=read(); ty=read();
scanf("%s",ch+1); fx=(ch[1]=='U')?1:((ch[1]=='D')?2:((ch[1]=='L')?3:4));
int ans=INF;
for(int p=1;p<=2;p++)
for(int i=1;i<=4;i++)
{
if(pos[p][id(x,y)][fx]>=INF||pos[p][id(tx,ty)][i]>=INF) continue;
if(pos[p][id(tx,ty)][i]>=pos[p][id(x,y)][fx]) ans=min(ans,pos[p][id(tx,ty)][i]-pos[p][id(x,y)][fx]);
else ans=min(ans,sum[p]+(pos[p][id(tx,ty)][i]-pos[p][id(x,y)][fx]));
}
printf("%lld\n",ans);
}
return 0;
}

T3 矩阵

解题思路

其实就是一个爆搜,显然如果有两个相邻的点数值相等答案就是 -1 。

否则的话由于是等比数列搜索深度不会超过 \(log\) 层,因此复杂度是对的。

code

#include<bits/stdc++.h>
#define int long long
#define ull unsigned long long
#define f() cout<<"RP++"<<endl
#define left Left
#define right Right
using namespace std;
inline int read()
{
int x=0,f=1;char ch=getchar();
while(ch>'9'||ch<'0'){if(ch=='-')f=-1;ch=getchar();}
while(ch>='0'&&ch<='9'){x=(x<<1)+(x<<3)+(ch^48);ch=getchar();}
return x*f;
}
const int N=4e4+10;
int n,m,ans=1;
int d1[10]={0,1,-1,0,0};
int d2[10]={0,0,0,1,-1};
unordered_map<int,int> mp[N];
vector<int> s[N];
inline int id(int x,int y){return (x-1)*m+y;}
inline bool check(){return (1.0*clock())/(1.0*CLOCKS_PER_SEC)<=0.98;}
void dfs(int x,int y,int dis,int num)
{
ans=max(ans,dis);
for(int i=1;i<=4;i++)
{
int nx=x+d1[i],ny=y+d2[i];
if(s[nx][ny]==s[x][y]*num)
dfs(nx,ny,dis+1,num);
}
}
void solve(int i,int j)
{
for(int k=1;k<=4;k++)
{
int x=i+d1[k],y=j+d2[k];
if(s[x][y]<s[i][j]||s[x][y]%s[i][j]) continue;
dfs(x,y,2,s[x][y]/s[i][j]);
}
}
#undef int
int main()
{
#define int long long
freopen("matrix.in","r",stdin); freopen("matrix.out","w",stdout);
n=read(); m=read(); for(int i=0;i<=m+1;i++) s[0].push_back(0),s[n+1].push_back(0);
for(int i=1;i<=n;i++)
{
s[i].push_back(0);
for(int j=1;j<=m;j++) s[i].push_back(read());
s[i].push_back(0);
}
for(int i=1;i<=n;i++)
for(int j=1;j<=m;j++)
for(int k=1;k<=4;k++)
{
int x=i+d1[k],y=j+d2[k];
if(s[x][y]==s[i][j]) printf("-1"),exit(0);
}
for(int i=1;i<=n&&check();i++)
for(int j=1;j<=m&&check();j++)
solve(i,j);
printf("%lld",ans);
return 0;
}

T4 乘法

大坑未补

NOIP模拟86(多校19)的更多相关文章

  1. NOIP模拟83(多校16)

    前言 CSP之后第一次模拟赛,感觉考的一般. 不得不吐槽多校联测 OJ 上的评测机是真的慢... T1 树上的数 解题思路 感觉自己思维有些固化了,一看题目就感觉是线段树. 考完之后才想起来这玩意直接 ...

  2. Noip模拟44 2021.8.19

    比较惊人的排行榜 更不用说爆零的人数了,为什么联赛会这么难!!害怕了 还要再努力鸭 T1 Emotional Flutter 考场上没切掉的神仙题 考率如何贪心,我们把黑色的条延长$s$,白色的缩短$ ...

  3. Noip模拟20 2021.7.19

    T1 玩具 题目读错意思直接报零... 拼接方式没读懂以为是个数学题,用卡特兰数,可是的确想多了 数据范围表达出你怎么暴力都行,选择$n^3,dp$ 相当于一片森林,每次多加一条边就合并成一棵树 在$ ...

  4. NOIP模拟92(多校25)

    前言 所以说这次是 HZOI 多校联测巅峰????(题目,数据过水??) T1 石子合并 解题思路 签到题. 发现我们可以给每个数字附一个正负号,每个数字的贡献就是它本身乘上这个符号. 发现至少应该有 ...

  5. NOIP模拟84(多校17)

    T1 宝藏 解题思路 考场上一眼出 \(nlog^2\) 做法,然后没看见是 1s 3e5 的数据,我竟然以为自己切了?? 考完之后尝试着把二分改为指针的移动,然后就过了??或许是数据水吧,感觉自己的 ...

  6. NOIP模拟85(多校18)

    前言 好像每个题目背景所描述的人都是某部番里的角色,热切好像都挺惨的(情感上的惨). 然后我只知道 T1 的莓,确实挺惨... T1 莓良心 解题思路 首先答案只与 \(w\) 的和有关系,于是问题就 ...

  7. NOIP模拟88(多校21)

    前言 对于这套题的总体感觉就是难,然后就是自己很菜... 对于 T1 考试时只会一个最垃圾的背包,考完之后对于思路这一块也不是很顺利,大概这就是薄弱的地方吧. 然后 T2 是比较简单的一道题了,但是考 ...

  8. NOIP模拟96(多校29)

    T1 子集和 解题思路 大概是一个退背包的大白板,然而我考场上想复杂了,竟然还用到了组合数. 但是大概意思是一样的,有数的最小值一定是一个在 \(a\) 数组中存在的数字. 那么我们想办法除去它对应的 ...

  9. NOIP模拟99(多校31)

    T1 法阵 解题思路 原题3100,张口放 T1(出题人原话) 思维题,合法的情况其实就是上下两个梯形拼起来的样子. 他们的边界都是在 \(i\) 轴上面,但是不能相交. 于是我们可以尝试两者相交的纵 ...

随机推荐

  1. 自定义组件 v-model 的使用

    关于自定义组件如何使用 v-model,本章直讲如何使用: 一. $emit('input', params) // 父组件中 <template> <article> {{f ...

  2. 利用 Nginx 搭建小型的文件服务器

    利用 Nginx 搭建小型的文件服务器 1.查看 Nginx 配置 android@localhost:/etc/nginx/conf.d$ nginx -hnginx version: nginx/ ...

  3. PHP中类的自动加载

    在之前,我们已经学习过Composer自动加载的原理,其实就是利用了PHP中的类自动加载的特性.在文末有该系列文章的链接. PHP中类的自动加载主要依靠的是__autoload()和spl_autol ...

  4. JS HTML5仿微信朋友圈特效

    完美! 图片相册翻页可定位在第几张,右上角可关闭. 源代码下载地址: 链接: https://pan.baidu.com/s/1o7PA7wu 密码: asyt

  5. Jmeter系列(13)- 数据库操作之JDBC Connection Configuration配置元件、JDBC Request取样器

    Jmeter常见操作数据库场景 准备.制造测试数据 获取.查询测试数据 数据库数据作为参数引用 清理测试环境.删除过程数据 数据库压测 Jmeter操作数据库环境准备 已经安装好的数据库,比如MySq ...

  6. P4590-[TJOI2018]游园会【dp套dp】

    正题 题目链接:https://www.luogu.com.cn/problem/P4590 题目大意 给出一个长度为\(m\)的字符串\(s\). 对于每个\(k\in[0,m]\)求有多少个长度为 ...

  7. LaTeX bib 引用为 作者 + 年份

    将bib文件命名为ref.bib %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% %%%%%%%% @Description: %%%%%%%% @Version: 1.0 %%%% ...

  8. kendoUI 多选下拉列表 kendoMultiSelect

    问题1:被重复渲染 点击新增按钮----弹出模态框 多选下拉列表在多选框中只是初始化过一次.但是每次点击新增后  发现 多选下拉列表 被重复渲染了 解决方案 在 新增时  先将其父元素div中  的s ...

  9. Spring技术内幕笔记2--我懒不写了哈哈哈哈。

    目录 1.1 关于IOC容器设计的线路区别 1.1.1 BeanFactory 1.1.2 ApplicationContext 2.1 FileSystemXmlApplicationContext ...

  10. 讲师征集| .NET Conf China 2021正式启动

    最近社区小伙伴们一直在为11月即将在武汉举办的 第三届.NET中国峰会而忙碌,社区活动官网设计和开发工作还在进行,我们在国庆节的前一天晚上向社区正式启动了活动的序幕,也就是我们确定好了举办地点.时间, ...